Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -7496,5 +6601,34 @@
 !> No calculation of window surface temperatures during spinup to increase maximum possible timstep
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE usm_surface_energy_balance( during_spinup )
+ SUBROUTINE usm_energy_balance( during_spinup )
+
+    LOGICAL       ::  during_spinup  !< flag indicating soil/wall spinup phase
+    INTEGER(iwp)  ::  l              !< loop index for surface types
+!
+!-- Call for horizontal surfaces
+    DO l = 0, 1
+       CALL usm_surface_energy_balance( .TRUE., l, during_spinup )
+       CALL usm_green_heat_model( .TRUE., l )
+       CALL usm_wall_heat_model( .TRUE., l, during_spinup )
+    ENDDO
+!
+!--   Call for vertical surfaces
+    DO l = 0, 3
+       CALL usm_surface_energy_balance( .FALSE., l, during_spinup )
+       CALL usm_green_heat_model( .FALSE., l )
+       CALL usm_wall_heat_model( .FALSE., l, during_spinup )
+    ENDDO
+
+ END SUBROUTINE usm_energy_balance
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Solver for the energy balance at the ground/roof/wall surface. It follows the basic ideas and
+!> structure of lsm_energy_balance with many simplifications and adjustments.
+!> TODO better description
+!> No calculation of window surface temperatures during spinup to increase maximum possible timstep
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE usm_surface_energy_balance( horizontal, l, during_spinup )
 
     USE exchange_horiz_mod,                                                                        &
@@ -7504,13 +6638,14 @@
     IMPLICIT NONE
 
-    INTEGER(iwp)  ::  dhour          !< simulated hour of day (in UTC)
-    INTEGER(iwp)  ::  i, j, k, l, m  !< running indices
-    INTEGER(iwp)  ::  i_off  !< offset to determine index of surface element, seen from atmospheric grid point, for x
-    INTEGER(iwp)  ::  j_off  !< offset to determine index of surface element, seen from atmospheric grid point, for y
-    INTEGER(iwp)  ::  k_off  !< offset to determine index of surface element, seen from atmospheric grid point, for z
-
-    LOGICAL  ::  during_spinup      !< flag indicating soil/wall spinup phase
-
-    REAL(wp)  ::  acoef              !< actual coefficient of diurnal profile of anthropogenic heat
+    LOGICAL       ::  horizontal     !< Flag indicating horizontal or vertical surfaces
+    INTEGER(iwp)  ::  l              !< direction index
+    LOGICAL       ::  during_spinup  !< flag indicating soil/wall spinup phase
+
+    INTEGER(iwp)  ::  i, j, k, m     !< running indices
+    INTEGER(iwp)  ::  i_off          !< offset to determine index of surface element, seen from atmospheric grid point, for x
+    INTEGER(iwp)  ::  j_off          !< offset to determine index of surface element, seen from atmospheric grid point, for y
+    INTEGER(iwp)  ::  k_off          !< offset to determine index of surface element, seen from atmospheric grid point, for z
+
+
     REAL(wp)  ::  coef_1             !< first coeficient for prognostic equation
     REAL(wp)  ::  coef_window_1      !< first coeficient for prognostic window equation
@@ -7519,5 +6654,4 @@
     REAL(wp)  ::  coef_window_2      !< second  coeficient for prognostic window equation
     REAL(wp)  ::  coef_green_2       !< second  coeficient for prognostic green wall equation
-    REAL(wp)  ::  dtime              !< simulated time of day (in UTC)
     REAL(wp)  ::  frac_win           !< window fraction, used to restore original values during spinup
     REAL(wp)  ::  frac_green         !< green fraction, used to restore original values during spinup
@@ -7557,14 +6691,52 @@
                   ueff                        !< limited near-surface wind speed - used for calculation of resistance
 
+    TYPE(surf_type),        POINTER ::  surf              !< surface-date type variable
+    TYPE(surf_type_1d_usm), POINTER ::  t_surf_green      !<
+    TYPE(surf_type_1d_usm), POINTER ::  t_surf_green_p    !<
+    TYPE(surf_type_1d_usm), POINTER ::  t_surf_wall       !<
+    TYPE(surf_type_1d_usm), POINTER ::  t_surf_wall_p     !<
+    TYPE(surf_type_1d_usm), POINTER ::  t_surf_window     !<
+    TYPE(surf_type_1d_usm), POINTER ::  t_surf_window_p   !<
+    TYPE(surf_type_2d_usm), POINTER ::  t_green           !<
+    TYPE(surf_type_2d_usm), POINTER ::  t_wall            !<
+    TYPE(surf_type_2d_usm), POINTER ::  t_window          !<
+
+    LOGICAL   ::  upward                      !< Flag indicating upward horizontal surfaces
 
     IF ( debug_output_timestep )  THEN
-       WRITE( debug_string, * ) 'usm_surface_energy_balance | during_spinup: ', during_spinup
+       WRITE( debug_string, * ) 'usm_surface_energy_balance:', horizontal, l, during_spinup
        CALL debug_message( debug_string, 'start' )
     ENDIF
+
+    upward = .FALSE.
+    IF ( horizontal )  THEN
+       surf              => surf_usm_h(l)
+       t_surf_wall       => t_surf_wall_h(l)
+       t_surf_wall_p     => t_surf_wall_h_p(l)
+       t_surf_window     => t_surf_window_h(l)
+       t_surf_window_p   => t_surf_window_h_p(l)
+       t_surf_green      => t_surf_green_h(l)
+       t_surf_green_p    => t_surf_green_h_p(l)
+       t_wall            => t_wall_h(l)
+       t_window          => t_window_h(l)
+       t_green           => t_green_h(l)
+       IF ( l == 0 ) upward = .TRUE.
+    ELSE
+       surf              => surf_usm_v(l)
+       t_surf_wall       => t_surf_wall_v(l)
+       t_surf_wall_p     => t_surf_wall_v_p(l)
+       t_surf_window     => t_surf_window_v(l)
+       t_surf_window_p   => t_surf_window_v_p(l)
+       t_surf_green      => t_surf_green_v(l)
+       t_surf_green_p    => t_surf_green_v_p(l)
+       t_wall            => t_wall_v(l)
+       t_window          => t_window_v(l)
+       t_green           => t_green_v(l)
+    ENDIF
 !
 !-- Index offset of surface element point with respect to adjoining atmospheric grid point
-    k_off = surf_usm_h%koff
-    j_off = surf_usm_h%joff
-    i_off = surf_usm_h%ioff
+    k_off = surf%koff
+    j_off = surf%joff
+    i_off = surf%ioff
 
 !
@@ -7577,36 +6749,28 @@
     !$OMP&                  stend_window, stend_green, tend, m_liq_max)
     !$OMP DO SCHEDULE (STATIC)
-    DO  m = 1, surf_usm_h%ns
+    DO  m = 1, surf%ns
 !
 !--    During spinup set green and window fraction to zero and restore at the end of the loop.
 !--    Note, this is a temporary fix and needs to be removed later.
        IF ( during_spinup )  THEN
-          frac_win                         = surf_usm_h%frac(m,ind_wat_win)
-          frac_wall                        = surf_usm_h%frac(m,ind_veg_wall)
-          frac_green                       = surf_usm_h%frac(m,ind_pav_green)
-          surf_usm_h%frac(m,ind_wat_win)   = 0.0_wp
-          surf_usm_h%frac(m,ind_veg_wall)  = 1.0_wp
-          surf_usm_h%frac(m,ind_pav_green) = 0.0_wp
+          frac_win                         = surf%frac(m,ind_wat_win)
+          frac_wall                        = surf%frac(m,ind_veg_wall)
+          frac_green                       = surf%frac(m,ind_pav_green)
+          surf%frac(m,ind_wat_win)   = 0.0_wp
+          surf%frac(m,ind_veg_wall)  = 1.0_wp
+          surf%frac(m,ind_pav_green) = 0.0_wp
        ENDIF
 !
 !--    Get indices of respective grid point
-       i = surf_usm_h%i(m)
-       j = surf_usm_h%j(m)
-       k = surf_usm_h%k(m)
+       i = surf%i(m)
+       j = surf%j(m)
+       k = surf%k(m)
 !
 !--    TODO - how to calculate lambda_surface for horizontal surfaces
-!--    (lambda_surface is set according to stratification in land surface model)
-!--    MS: ???
-       IF ( surf_usm_h%ol(m) >= 0.0_wp )  THEN
-          lambda_surface        = surf_usm_h%lambda_surf(m)
-          lambda_surface_window = surf_usm_h%lambda_surf_window(m)
-          lambda_surface_green  = surf_usm_h%lambda_surf_green(m)
-       ELSE
-          lambda_surface        = surf_usm_h%lambda_surf(m)
-          lambda_surface_window = surf_usm_h%lambda_surf_window(m)
-          lambda_surface_green  = surf_usm_h%lambda_surf_green(m)
-       ENDIF
-
-!        pt1  = pt(k,j,i)
+!--    (lambda_surface shoud be set according to stratification in land surface model)
+       lambda_surface        = surf%lambda_surf(m)
+       lambda_surface_window = surf%lambda_surf_window(m)
+       lambda_surface_green  = surf%lambda_surf_green(m)
+
        IF ( humidity )  THEN
           qv1 = q(k,j,i)
@@ -7616,7 +6780,7 @@
 !
 !--    Calculate rho * c_p coefficient at surface layer
-       rho_cp  = c_p * hyp(k) / ( r_d * surf_usm_h%pt1(m) * exner(k) )
-
-       IF ( surf_usm_h%frac(m,ind_pav_green) > 0.0_wp )  THEN
+       rho_cp  = c_p * hyp(k) / ( r_d * surf%pt1(m) * exner(k) )
+
+       IF ( surf%frac(m,ind_pav_green) > 0.0_wp )  THEN
 !
 !--       Calculate frequently used parameters
@@ -7627,93 +6791,108 @@
 !
 !--    Calculate aerodyamic resistance.
-!--    Calculation for horizontal surfaces follows LSM formulation pt, us, ts are not available for
-!--    the prognostic time step, data from the last time step is used here.
-!
-!--    Workaround: use single r_a as stability is only treated for the average temperature
-       surf_usm_h%r_a(m)        = ( surf_usm_h%pt1(m) - surf_usm_h%pt_surface(m) ) /               &
-                                  ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
-       surf_usm_h%r_a_window(m) = surf_usm_h%r_a(m)
-       surf_usm_h%r_a_green(m)  = surf_usm_h%r_a(m)
-
-!        r_a        = ( surf_usm_h%pt1(m) - t_surf_h(m) / exner(k) ) /                              &
-!                     ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
-!        r_a_window = ( surf_usm_h%pt1(m) - t_surf_window_h(m) / exner(k) ) /                       &
-!                     ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
-!        r_a_green  = ( surf_usm_h%pt1(m) - t_surf_green_h(m) / exner(k) ) /                        &
-!                     ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
+       IF ( upward ) THEN
+!--       Calculation for horizontal upward facing surfaces follows LSM formulation
+!--       pt, us, ts are not available for the prognostic time step, data from the
+!--       last time step is used here.
+!--       Workaround: use single r_a as stability is only treated for the average temperature
+          surf%r_a(m)        = ( surf%pt1(m) - surf%pt_surface(m) ) /               &
+                                     ( surf%ts(m) * surf%us(m) + 1.0E-20_wp )
+       ELSE
+!--           Calculation of r_a for vertical and downward facing horizontal surfaces
+!--
+!--           Heat transfer coefficient for forced convection along vertical walls follows formulation
+!--           in TUF3d model (Krayenhoff & Voogt, 2006)
+!--
+!--           H = httc (Tsfc - Tair)
+!--           httc = rw * (11.8 + 4.2 * Ueff) - 4.0
+!--
+!--                rw: Wall patch roughness relative to 1.0 for concrete
+!--                Ueff: Effective wind speed
+!--                - 4.0 is a reduction of Rowley et al (1930) formulation based on
+!--                Cole and Sturrock (1977)
+!--
+!--                Ucan: Canyon wind speed
+!--                wstar: Convective velocity
+!--                Qs: Surface heat flux
+!--                zH: Height of the convective layer
+!--                wstar = (g/Tcan*Qs*zH)**(1./3.)
+!--           Effective velocity components must always be defined at scalar grid point. The wall
+!--           normal component is obtained by simple linear interpolation. (An alternative would be an
+!--           logarithmic interpolation.) Parameter roughness_concrete (default value = 0.001) is used
+!--           to calculation of roughness relative to concrete. Note, wind velocity is limited
+!--           to avoid division by zero. The nominator can become <= 0.0 for values z0 < 3*10E-4.
+              ueff        = MAX ( SQRT( ( ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp )**2 +                  &
+                                        ( ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp )**2 +                  &
+                                        ( ( w(k,j,i) + w(k-1,j,i) ) * 0.5_wp )**2 ),                 &
+                                  ( ( 4.0_wp + 0.1_wp )                                              &
+                                    / ( surf%z0(m) * d_roughness_concrete )                 &
+                                   - 11.8_wp ) / 4.2_wp                                              &
+                                 )
+
+              surf%r_a(m) = rho_cp / ( surf%z0(m) * d_roughness_concrete            &
+                                     * ( 11.8_wp + 4.2_wp * ueff )  - 4.0_wp  )
+       ENDIF
 
 !--    Make sure that the resistance does not drop to zero
-       IF ( surf_usm_h%r_a(m)        < 1.0_wp )  surf_usm_h%r_a(m)        = 1.0_wp
-       IF ( surf_usm_h%r_a_green(m)  < 1.0_wp )  surf_usm_h%r_a_green(m)  = 1.0_wp
-       IF ( surf_usm_h%r_a_window(m) < 1.0_wp )  surf_usm_h%r_a_window(m) = 1.0_wp
-
-!
-!--    Make sure that the resistacne does not exceed a maxmium value in case of zero velocities
-       IF ( surf_usm_h%r_a(m)        > 300.0_wp )  surf_usm_h%r_a(m)        = 300.0_wp
-       IF ( surf_usm_h%r_a_green(m)  > 300.0_wp )  surf_usm_h%r_a_green(m)  = 300.0_wp
-       IF ( surf_usm_h%r_a_window(m) > 300.0_wp )  surf_usm_h%r_a_window(m) = 300.0_wp
-
+!--    end does not exceed a maxmium value in case of zero velocities
+       IF ( surf%r_a(m)        < 1.0_wp )  surf%r_a(m)        = 1.0_wp
+       IF ( surf%r_a(m)        > 300.0_wp )  surf%r_a(m)        = 300.0_wp
+!
+!--    Aeorodynamical resistance for the window and green fractions are set to the same value
+       surf%r_a_window(m) = surf%r_a(m)
+       surf%r_a_green(m)  = surf%r_a(m)
 !
 !--    Factor for shf_eb
-       f_shf         = rho_cp / surf_usm_h%r_a(m)
-       f_shf_window  = rho_cp / surf_usm_h%r_a_window(m)
-       f_shf_green   = rho_cp / surf_usm_h%r_a_green(m)
-
-
-       IF ( surf_usm_h%frac(m,ind_pav_green) > 0.0_wp )  THEN
+       f_shf         = rho_cp / surf%r_a(m)
+       f_shf_window  = rho_cp / surf%r_a_window(m)
+       f_shf_green   = rho_cp / surf%r_a_green(m)
+
+       IF ( surf%frac(m,ind_pav_green) > 0.0_wp )  THEN
+!
 !--       Adapted from LSM:
-!--       Second step: calculate canopy resistance r_canopy f1-f3 here are defined as 1/f1-f3 as in
-!--       ECMWF documentation
+!--       Second step: calculate canopy resistance r_canopy. f1-f3 here are defined as 1/f1-f3
+!--       as in ECMWF documentation
 
 !--       f1: Correction for incoming shortwave radiation (stomata close at night)
-          f1 = MIN( 1.0_wp, ( 0.004_wp * surf_usm_h%rad_sw_in(m) + 0.05_wp ) /                     &
-                    (0.81_wp * ( 0.004_wp * surf_usm_h%rad_sw_in(m) + 1.0_wp ) ) )
+          f1 = MIN( 1.0_wp, ( 0.004_wp * surf%rad_sw_in(m) + 0.05_wp ) /                     &
+                    (0.81_wp * ( 0.004_wp * surf%rad_sw_in(m) + 1.0_wp ) ) )
 !
 !--       f2: Correction for soil moisture availability to plants (the integrated soil moisture must
 !--       thus be considered here) f2 = 0 for very dry soils
-          m_total = 0.0_wp
-          DO  k = nzb_wall, nzt_wall+1
-              m_total = m_total + rootfr_h(nzb_wall,m) * MAX( swc_h(nzb_wall,m),wilt_h(nzb_wall,m) )
-          ENDDO
-
-          IF ( m_total > wilt_h(nzb_wall,m)  .AND.  m_total < fc_h(nzb_wall,m) )  THEN
-             f2 = ( m_total - wilt_h(nzb_wall,m) ) / (fc_h(nzb_wall,m) - wilt_h(nzb_wall,m) )
-          ELSEIF ( m_total >= fc_h(nzb_wall,m) )  THEN
-             f2 = 1.0_wp
+          IF ( upward ) THEN
+             m_total = 0.0_wp
+             DO  k = nzb_wall, nzt_wall+1
+                 m_total = m_total + rootfr_h(l)%val(nzb_wall,m) &
+                                     * MAX( swc_h(l)%val(nzb_wall,m),wilt_h(l)%val(nzb_wall,m) )
+             ENDDO
+
+             IF ( m_total > wilt_h(l)%val(nzb_wall,m)  .AND.  m_total < fc_h(l)%val(nzb_wall,m) )  THEN
+                f2 = ( m_total - wilt_h(l)%val(nzb_wall,m) ) / (fc_h(l)%val(nzb_wall,m) - wilt_h(l)%val(nzb_wall,m) )
+             ELSEIF ( m_total >= fc_h(l)%val(nzb_wall,m) )  THEN
+                f2 = 1.0_wp
+             ELSE
+                f2 = 1.0E-20_wp
+             ENDIF
           ELSE
-             f2 = 1.0E-20_wp
-          ENDIF
-
+             f2=1.0_wp
+          ENDIF
 !
 !--       Calculate water vapour pressure at saturation
-          e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surf_green_h(m) - 273.16_wp )           &
-                                           / ( t_surf_green_h(m) - 35.86_wp ) )
+          e_s = 0.01_wp * magnus_tl( t_surf_green%val(m) )
 !
 !--       f3: Correction for vapour pressure deficit
-          IF ( surf_usm_h%g_d(m) /= 0.0_wp )  THEN
-!
-!--       Calculate vapour pressure
+          IF ( surf%g_d(m) /= 0.0_wp )  THEN
+!--          Calculate vapour pressure
              e  = qv1 * surface_pressure / ( qv1 + 0.622_wp )
-             f3 = EXP ( - surf_usm_h%g_d(m) * (e_s - e) )
+             f3 = EXP ( - surf%g_d(m) * (e_s - e) )
           ELSE
              f3 = 1.0_wp
           ENDIF
-
 !
 !--       Calculate canopy resistance. In case that c_veg is 0 (bare soils), this calculation is
 !--       obsolete, as r_canopy is not used below.
 !--       To do: check for very dry soil -> r_canopy goes to infinity
-          surf_usm_h%r_canopy(m) = surf_usm_h%r_canopy_min(m) /                                    &
-                                  ( surf_usm_h%lai(m) * f1 * f2 * f3 + 1.0E-20_wp )
-
-!
-!--       Calculate the maximum possible liquid water amount on plants and bare surface. For
-!--       vegetated surfaces, a maximum depth of 0.2 mm is assumed, while paved surfaces might hold
-!--       up 1 mm of water. The liquid water fraction for paved surfaces is calculated after
-!--       Noilhan & Planton (1989), while the ECMWF formulation is used for vegetated surfaces and
-!--       bare soils.
-          m_liq_max = m_max_depth * ( surf_usm_h%lai(m) )
-
-          surf_usm_h%c_liq(m) = MIN( 1.0_wp, ( m_liq_usm_h%var_usm_1d(m) / m_liq_max )**0.67 )
+          surf%r_canopy(m) = surf%r_canopy_min(m) /                                    &
+                                  ( surf%lai(m) * f1 * f2 * f3 + 1.0E-20_wp )
 !
 !--       Calculate saturation specific humidity
